#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.0"

public Plugin:myinfo =
{
	name = "DoD Domination Broadcast",
	author = "FeuerSturm",
	description = "Disable Domination&Revenge Broadcasting",
	version = PLUGIN_VERSION,
	url = "http://www.dodsplugins.net"
}

new Handle:Broadcast = INVALID_HANDLE
new m_bPlayerDominatingMe, m_bPlayerDominated

public OnPluginStart()
{
	Broadcast = CreateConVar("dod_domination_broadcast", "1", "<1/0> = enable/disable Domination & Revenge broadcasting", FCVAR_PLUGIN, true, 0.0, true, 1.0)
	HookEvent("player_death", PrePlayerDeath, EventHookMode_Pre)
}

public OnMapStart()
{
	m_bPlayerDominatingMe = FindSendPropInfo("CDODPlayer", "m_bPlayerDominatingMe")
	m_bPlayerDominated = FindSendPropInfo("CDODPlayer", "m_bPlayerDominated")
}

public Action:PrePlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(GetConVarInt(Broadcast) == 0)
	{
		new domination = GetEventBool(event, "dominated")
		new revenge = GetEventBool(event, "revenge")
		if(domination)
		{
			new killer = GetClientOfUserId(GetEventInt(event, "attacker"))
			new victim = GetClientOfUserId(GetEventInt(event, "userid"))
			SetEventBool(event, "dominated", false)
			NoBroadcast(killer, victim)
			return Plugin_Continue
		}
		if(revenge)
		{
			SetEventBool(event, "revenge", false)
			return Plugin_Continue
		}
	}
	return Plugin_Continue
}

stock NoBroadcast(killer, victim)
{
	SetEntData(victim, m_bPlayerDominatingMe + killer, 0, 1, true)
	SetEntData(killer, m_bPlayerDominated + victim, 0, 1, true)
}